<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Skinetic BeatSaber mod - Documentation</title>
  <style>
    html {
      color: #1a1a1a;
      background-color: #fdfdfd;
    }
    body {
      margin: 0 auto;
      max-width: 36em;
      padding-left: 50px;
      padding-right: 50px;
      padding-top: 50px;
      padding-bottom: 50px;
      hyphens: auto;
      overflow-wrap: break-word;
      text-rendering: optimizeLegibility;
      font-kerning: normal;
    }
    @media (max-width: 600px) {
      body {
        font-size: 0.9em;
        padding: 12px;
      }
      h1 {
        font-size: 1.8em;
      }
    }
    @media print {
      html {
        background-color: white;
      }
      body {
        background-color: transparent;
        color: black;
        font-size: 12pt;
      }
      p, h2, h3 {
        orphans: 3;
        widows: 3;
      }
      h2, h3, h4 {
        page-break-after: avoid;
      }
    }
    p {
      margin: 1em 0;
    }
    a {
      color: #1a1a1a;
    }
    a:visited {
      color: #1a1a1a;
    }
    img {
      max-width: 100%;
    }
    h1, h2, h3, h4, h5, h6 {
      margin-top: 1.4em;
    }
    h5, h6 {
      font-size: 1em;
      font-style: italic;
    }
    h6 {
      font-weight: normal;
    }
    ol, ul {
      padding-left: 1.7em;
      margin-top: 1em;
    }
    li > ol, li > ul {
      margin-top: 0;
    }
    blockquote {
      margin: 1em 0 1em 1.7em;
      padding-left: 1em;
      border-left: 2px solid #e6e6e6;
      color: #606060;
    }
    code {
      font-family: Menlo, Monaco, Consolas, 'Lucida Console', monospace;
      font-size: 85%;
      margin: 0;
      hyphens: manual;
    }
    pre {
      margin: 1em 0;
      overflow: auto;
    }
    pre code {
      padding: 0;
      overflow: visible;
      overflow-wrap: normal;
    }
    .sourceCode {
     background-color: transparent;
     overflow: visible;
    }
    hr {
      background-color: #1a1a1a;
      border: none;
      height: 1px;
      margin: 1em 0;
    }
    table {
      margin: 1em 0;
      border-collapse: collapse;
      width: 100%;
      overflow-x: auto;
      display: block;
      font-variant-numeric: lining-nums tabular-nums;
    }
    table caption {
      margin-bottom: 0.75em;
    }
    tbody {
      margin-top: 0.5em;
      border-top: 1px solid #1a1a1a;
      border-bottom: 1px solid #1a1a1a;
    }
    th {
      border-top: 1px solid #1a1a1a;
      padding: 0.25em 0.5em 0.25em 0.5em;
    }
    td {
      padding: 0.125em 0.5em 0.25em 0.5em;
    }
    header {
      margin-bottom: 4em;
      text-align: center;
    }
    #TOC li {
      list-style: none;
    }
    #TOC ul {
      padding-left: 1.3em;
    }
    #TOC > ul {
      padding-left: 0;
    }
    #TOC a:not(:hover) {
      text-decoration: none;
    }
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    div.columns{display: flex; gap: min(4vw, 1.5em);}
    div.column{flex: auto; overflow-x: auto;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
    ul.task-list li input[type="checkbox"] {
      width: 0.8em;
      margin: 0 0.8em 0.2em -1.6em;
      vertical-align: middle;
    }
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
  <!--[if lt IE 9]>
    <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.3/html5shiv-printshiv.min.js"></script>
  <![endif]-->
</head>
<body>
<header id="title-block-header">
<h1 class="title">Skinetic BeatSaber mod - Documentation</h1>
</header>
<h1 id="beat-saber---skinetic-mod">Beat Saber - Skinetic Mod</h1>
<p align="center">
<p><a href="https://discord.gg/55u4DsCP82"><img
src="https://dcbadge.vercel.app/api/server/55u4DsCP82"
alt="Skinetic Discord" /></a></p>
</p>
<p><strong>Support for Skinetic haptic vest on Beat Saber
interactions.</strong></p>
<blockquote>
<p>⚠ This mod uses <em>Skinetic SDK v1.2.0</em> and must be used with
Skinetic Vest version 1.1.3 or later</p>
</blockquote>
<h2 id="description">Description</h2>
<p>This mod adds haptic feedback to the Skinetic vest.</p>
<p>It provides distinct effects for these in-game interactions: -
Perfect Note Slicing <em>(left/right)</em> - Imperfect Note Slicing
<em>(left/right)</em> - Bomb exploding <em>(left/right)</em> - Missed
Note - Wall collision - Level cleared - Level failed</p>
<hr />
<h2 id="table-of-contents">Table of Contents</h2>
<ul>
<li><a href="#usage">Usage</a>
<ul>
<li><a href="#requirements">Requirements</a></li>
<li><a href="#install">Install</a></li>
<li><a href="#launch">Launch</a></li>
<li><a href="#settings">Settings</a></li>
<li><a href="#edit-haptic-patterns">Edit Haptic Patterns</a></li>
</ul></li>
<li><a href="#mod-edition">Mod Edition</a>
<ul>
<li><a href="#project">Project</a></li>
<li><a href="#code-structure">Code Structure</a></li>
</ul></li>
<li><a href="#version-history">Version History</a></li>
<li><a href="#license">License</a></li>
<li><a href="#help">Help</a></li>
</ul>
<hr />
<h2 id="usage">Usage</h2>
<h3 id="requirements">Requirements</h3>
<ul>
<li><strong>Skinetic</strong> Vest</li>
<li><a href="https://beatsaber.com/#start-playing"><strong>Beat
Saber</strong></a> for PCVR</li>
<li><em>(optional)</em> <a
href="https://github.com/Assistant/ModAssistant"><strong>ModAssistant</strong></a></li>
<li><a
href="https://nike4613.github.io/BeatSaber-IPA-Reloaded/"><strong>BSIPA</strong></a>
(can also be installed by <em>ModAssistant</em>)</li>
</ul>
<h3 id="install">Install</h3>
<ul>
<li>Install BSIPA (from ModAssistant or standalone)</li>
<li>Extract the archive to the root folder of your game
<ul>
<li>If you use Steam with default game location, it should be in
<code>C:\Program Files\Steam\steamapps\common\Beat Saber</code></li>
<li>It should put <code>SkineticSDK.dll</code> in the <em>Libs</em>
folder, and <code>Skinetic_BeatSaber_Mod.dll</code> in
<em>Plugins</em></li>
</ul></li>
</ul>
<h3 id="launch">Launch</h3>
<ul>
<li>Turn on the Skinetic vest</li>
<li>Connect it with usb or turn on Bluetooth (pair it to your computer
if needed)</li>
<li>Start the game as usual</li>
</ul>
<blockquote>
<p>The vest will indicate its connection with a small haptic
feedback.</p>
</blockquote>
<h3 id="settings">Settings</h3>
<p>On first start, the mod should create a
<code>Skinetic_BeatSaber_Mod.json</code> file inside the
<em>UserData</em> directory.</p>
<p>The <code>Skinetic_BeatSaber_Mod.json</code> file can be edited with
any text editor. It contains 3 editable values:</p>
<ul>
<li><p><strong>DefaultVolume</strong>: Controls the global volume of the
patterns (in %). The value can be set from 0 to 250. At 100, the
patterns base volume is preserved and rendered as intended. Between 0
and 99, it’s attenuated. Between 101 and 250, the volume is increased,
which can lead to distortion of the effects and product audible
noise.</p></li>
<li><p><strong>SerialNumber</strong>: Default value is 0. This is the
serial number of the Skinetic vest the mod will try to connect to. 0
means the first available Skinetic vest. This setting should only be
changed if multiple vests are paired to the PC being used.</p></li>
<li><p><strong>BoostPercent</strong>: int. From 0 to 100. Default value
is 0%. This setting allows the end user to globally boost the effects
played on the vest. At 0%, no boost is applied. From 1 to 100%, each
pattern is <strong>altered</strong> to create a more punchy feel on
Skinetic. For this mod, keeping this value below 40% will preserve most
of the intended feel of each effect.</p></li>
</ul>
<h3 id="edit-haptic-patterns">Edit Haptic Patterns</h3>
<p>At first start, the mod should also create a new folder
<code>SkineticPatterns</code> with the different haptic patterns inside
the <em>UserData</em> directory.</p>
<p>Patterns located in <code>UserData/SkineticPatterns/</code> can be
modified using <a
href="https://www.skinetic.actronika.com/unitouch-studio"><strong>Unitouch
Studio</strong></a>. Each <code>[patternName].spn</code> file can be
directly loaded and modified in the studio or completely replaced by a
new file. To be triggered correctly, the new file must have the same
name as the one it replaces.</p>
<p>To reset the patterns, simply delete or rename the folder containing
them. This will force the mod to regenerate them the next times it
starts.</p>
<hr />
<h2 id="mod-edition">Mod edition</h2>
<p>For more advanced users and mod developprs, this mod can be easily
edited and updated.</p>
<h3 id="project">Project</h3>
<ul>
<li>This project is a Visual Code project based on the BSIPA template.
(See <a href="https://bsmg.wiki/modding/pc-mod-dev-intro.html">BSIPA PC
Mod Development Documentation</a>). This template simplifies the task by
allowing you to select the location of the game files and automatically
build and move the mod to the right place for testing.</li>
</ul>
<h3 id="code-structure">Code structure</h3>
<p>The <em>SkineticSDK library</em> is located in the <code>libs</code>
folder.</p>
<p>Haptic patterns file are in the <code>SkineticPatterns</code>
directory and should only be replaced or updated but never removed or
renamed for the mod to work properly as is.</p>
<p>Each pattern is loaded as a text Resource within the Visual Studio
project. Additional patterns must also be added to be automatically
generated by the mod on first start. <em>(See Project Properties &gt;
Resources menu).</em></p>
<p>Interesting code files are separated into 3 folders:</p>
<ul>
<li>In the root folder:
<ul>
<li><code>Skinetic_BeatSaber_ModController.cs</code>: This is the main
class of the mod. It contains all mod patches and loads them into the
game using <em>Harmony</em>. Each patch calls Skinetic Manager methods
to communicate with the vest.</li>
</ul></li>
<li>In the <code>Skinetic</code> folder:
<ul>
<li><code>SkineticWrapping.cs</code>: This is the wrapper for the
SkineticSDK dll. It handles basic conversion from C# to C++. It also
contains documentation for each of the available methods. <strong>Should
not be modified</strong>.</li>
<li><code>SkineticManager.cs</code>: <em>Skinetic Manager</em> is a
class designed to simplify the use of the SDK itself. It handles basic
tasks such as initialization, connection/disconnection, pattern loading,
automatic pattern folder generation on startup and also simplified
play/stop methods. <strong>This class can be adapted to better suit your
needs.</strong></li>
</ul></li>
<li>In the <code>Configuration</code> folder:
<ul>
<li><code>PluginConfig.cs</code>: This class contains all settings that
are editable in the json itself. Values defined here are default values.
Each variable can be accessed by other classes using
<code>PluginConfig.Instance.[VarName]</code></li>
</ul></li>
</ul>
<h2 id="version-history">Version History</h2>
<ul>
<li>1.0.0
<ul>
<li>Initial release</li>
</ul></li>
</ul>
<h2 id="license">License</h2>
<ul>
<li>This mod is licensed under LGPL-v3.</li>
<li>It includes Skinetic SDK as a closed-source library. See <a
href="./ACTRONIKA%20-%20CGL%20Skinetic%20SDK%20-%20EN.pdf">Skinetic SDK
CGL</a>.</li>
</ul>
<h2 id="help">Help</h2>
<p>To get help, discuss good practices or report any issue, join the <a
href="https://discord.gg/55u4DsCP82">Skinetic discord server</a>.</p>
</body>
</html>
